{*************************************************************************}
{ GH Freebrary                                                            }
{                                                                         }
{ GHFObjListEx.pas - TghObjListEx class unit.                             }
{                                                                         }
{ This software is distributed under the open source BSD license.         }
{                                                                         }
{ Copyright (c) 2002-2013, Al Gonzalez (rescatandoadelphi.blogspot.com)   }
{ All rights reserved.                                                    }
{                                                                         }
{ Redistribution and use in source and binary forms, with or without      }
{ modification, are permitted provided that the following conditions are  }
{ met:                                                                    }
{                                                                         }
{   - Redistributions of source code must retain the above copyright      }
{     notice, this list of conditions and the following disclaimer.       }
{   - Redistributions in binary form must reproduce the above copyright   }
{     notice, this list of conditions and the following disclaimer in the }
{     documentation and/or other materials provided with the              }
{     distribution.                                                       }
{   - Neither the name of Al Gonzalez nor the names of his contributors   }
{     may be used to endorse or promote products derived from this        }
{     software without specific prior written permission.                 }
{                                                                         }
{ THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS }
{ IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED   }
{ TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A         }
{ PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      }
{ HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  }
{ SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        }
{ LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   }
{ DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   }
{ THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     }
{ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   }
{ OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    }
{*************************************************************************}

{ Please contribute to improve this library.  I am not a good programmer,
  but good programmers know what Delphi is worth.

  A.G. }

Unit GHFObjListEx;  { Object List Extended }

Interface

  Uses
    GHFObjList, VCL.Controls;

  Type
    { Object List Extended class }
    TghObjListEx = Class (TghObjList)
      Public
        { Static methods }
        Function AddControls (Const Parent :TWinControl;
          Const Cls :TControlClass = Nil; Const Recurse :Boolean = False)
          :Integer; Overload;
        Function AddControls (Const Parent :TWinControl;
          Const Recurse :Boolean) :Integer; Overload;
    End;

Implementation

  { TghObjListEx }

  { Public static methods }

  Function TghObjListEx.AddControls (Const Parent :TWinControl;
    Const Cls :TControlClass = Nil; Const Recurse :Boolean = False)
    :Integer;
  Var
    I :Integer;
  Begin
    Result := 0;

    For I := 0 To Parent.ControlCount - 1 Do
    Begin
      If (Cls = Nil) Or (Parent.Controls [I] Is Cls) Then
      Begin
        Add (Parent.Controls [I]);
        Inc (Result);
      End;

      If Recurse And (Parent.Controls [I] Is TWinControl) Then
        Inc (Result, AddControls (TWinControl (Parent.Controls [I]), Cls,
          True));
    End;
  End;

  Function TghObjListEx.AddControls (Const Parent :TWinControl;
    Const Recurse :Boolean) :Integer;
  Begin
    Result := AddControls (Parent, TControlClass (Nil), Recurse);
  End;

End.

